<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class ImageService
    {

    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix = null;

    function __construct($db, $table_prefix)
        {
        $this->_db         =$db;
        $this->table_prefix=$table_prefix;
        }

    public function getNum()
        {
        $sql   ="select count(*) as num from " . $this->table_prefix . "images";
        $result=$this->_db->query($sql);
        $num   =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $num['num'];
        }

    public function checkAddForm($data, $images)
        {
        $error=array();

        for ($i=0; $i < $data['rows_per_page']; $i++)
            {
            $flag = false;

            foreach ($images['media_file' . $i]['error'] as $index => $e)
                {
                if ($e == UPLOAD_ERR_OK)
                    {
                    $flag=true;
                    }
                }

            foreach ($data['remote_media_file' . $i] as $index => $value)
                {
                if (!checkBlank($value) and checkDomain($value))
                    {
                    $flag=true;
                    }
                }

            if ($flag == false)
                {
                $error['image_media' . $i]=1;
                }

            if (checkBlank($data['name' . $i]))
                {
                $error['image_name' . $i]=1;
                }
            }

        return $error;
        }

    public function checkUpdateForm($data, $image)
        {
        $error=array();

        if ($image['media_file']['error'] == UPLOAD_ERR_OK and !checkBlank(
                                                                    $data['remote_media_file']) or !checkBlank(
                                                                                                        $data['remote_media_file'])
                                                                                                       and !checkDomain(
                                                                                                                $data['remote_media_file']))
            {
            $error['image_media']=1;
            }

        if (checkBlank($data['name']))
            {
            $error['image_name']=1;
            }

        if (!checkTime($data['create_time']))
            {
            $error['image_create_time']=1;
            }

        if (!checkInt($data['downloads']))
            {
            $error['image_downloads']=1;
            }

        if (!checkInt($data['votes']))
            {
            $error['image_votes']=1;
            }

        if (!checkFloat($data['votes']))
            {
            $error['image_rating']=1;
            }

        if (!checkInt($data['hits']))
            {
            $error['image_hits']=1;
            }

        return $error;
        }

    public function save($data, $images)
        {
        for ($i=0; $i < $data['rows_per_page']; $i++)
            {
            $cat_id           = $data['category' . $i];
            $dest_folder      ='';
            $user_id          =$data['user' . $i];
            $image_name       =$data['name' . $i];
            $image_description=$data['description' . $i];
            $image_keyword_ids=$this->convertWordToCode($data['keywords' . $i]);
            $image_create_time=$image_edit_time=time();
            $image_active     =$data['active' . $i];

            foreach ($images['media_file' . $i]['error'] as $index => $error)
                {
                if ($error == UPLOAD_ERR_OK)
                    {
                    $tmp_name      =$images["media_file" . $i]["tmp_name"][$index];
                    $image_filename=md5(uniqid(rand(), true)) . '_' . $images["media_file" . $i]["name"][$index];

                    if ($dest_folder == '')
                        {
                        $dest_folder=ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($cat_id);
                        }

                    $uploadfile=$dest_folder . $image_filename;
                    /*
                                        if (!file_exists($dest_folder))
                                            {
                                            mkdir($dest_folder, 0777);
                                            }
                    */
                    if (move_uploaded_file($tmp_name, $uploadfile))
                        {
                        chmod($uploadfile, 0777);
                        }
                    else
                        {
                        return false;
                        }

                    $image_size        =$images['media_file' . $i]['size'][$index];
                    $temp              =getimagesize($uploadfile);
                    $image_width       =$temp[0];
                    $image_height      =$temp[1];
                    $image_download_url='';

                    $sql               ="insert into " . $this->table_prefix
                        . "images(cat_id,user_id,image_name,image_description,image_keyword_ids,image_create_time,image_edit_time,image_active,image_filename,image_size,image_width,image_height,image_download_url)values('"
                        . $cat_id . "','" . $user_id . "','" . $image_name . "','" . $image_description . "','"
                        . $image_keyword_ids . "','" . $image_create_time . "','" . $image_edit_time . "','"
                        . $image_active . "','" . $image_filename . "','" . $image_size . "','" . $image_width . "','"
                        . $image_height . "','" . $image_download_url . "')";
                    $result            =$this->_db->query($sql);

                    if ($result == false)
                        {
                        return false;
                        }
                    }
                }

            foreach ($data['remote_media_file' . $i] as $index => $value)
                {
                if (!checkBlank($value))
                    {
                    $image_filename=md5(uniqid(rand(), true)) . '_' . basename($data['remote_media_file' . $i][$index]);
                    $temp          =get_headers($data['remote_media_file' . $i][$index], true);

                    if (!is_null($temp['Content-Length']) and is_numeric($temp['Content-Length']))
                        {
                        $image_size=$temp['Content-Length'];
                        }
                    else
                        {
                        continue;
                        }

                    $temp              =getimagesize($data['remote_media_file' . $i][$index]);
                    $image_width       =$temp[0];
                    $image_height      =$temp[1];
                    $image_download_url=$data['remote_media_file' . $i][$index];

                    $sql               ="insert into " . $this->table_prefix
                        . "images(cat_id,user_id,image_name,image_description,image_keyword_ids,image_create_time,image_edit_time,image_active,image_filename,image_size,image_width,image_height,image_download_url)values('"
                        . $cat_id . "','" . $user_id . "','" . $image_name . "','" . $image_description . "','"
                        . $image_keyword_ids . "','" . $image_create_time . "','" . $image_edit_time . "','"
                        . $image_active . "','" . $image_filename . "','" . $image_size . "','" . $image_width . "','"
                        . $image_height . "','" . $image_download_url . "')";
                    $result            =$this->_db->query($sql);

                    if ($result == false)
                        {
                        return false;
                        }
                    }
                }
            }

        return true;
        }

    public function update($data, $image)
        {
        $image_id=$data['id'];

        //delete media data first
        if ($image['media_file']['error'] == UPLOAD_ERR_OK or $data['remote_media_file'] != '')
            {
            $oldImage=$this->searchById($image_id);

            if ($oldImage['image_download_url'] == '')
                {
                $dest_folder=ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($oldImage['cat_id']);
                $uploadfile =$dest_folder . $oldImage['image_filename'];

                if (file_exists($uploadfile))
                    {
                    if (!unlink($uploadfile))
                        {
                        return false;
                        }
                    }
                }
            }

        $cat_id             =$data['category'];
        $user_id            =$data['user'];
        $image_name         =$data['name'];
        $image_description  =$data['description'];
        $image_keyword_ids  =$this->convertWordToCode($data['keywords']);
        $data['create_time']=timeTrans($data['create_time']);
        $image_create_time  =$data['create_time'];
        $image_edit_time    =time();
        $image_active       =$data['active'];
        $image_downloads    =$data['downloads'];
        $image_votes        =$data['votes'];
        $image_rating       =$data['rating'];
        $image_hits         =$data['hits'];

        //add    
        if ($image['media_file']['error'] == UPLOAD_ERR_OK)
            {
            $tmp_name      =$image["media_file"]["tmp_name"];
            $image_filename=md5(uniqid(rand(), true)) . '_' . $image["media_file"]["name"];
            $dest_folder   =ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($cat_id);
            $uploadfile    =$dest_folder . $image_filename;
            /*
                        if (!file_exists($dest_folder))
                            {
                            mkdir($dest_folder, 0777, true);
                            }
            */
            if (move_uploaded_file($tmp_name, $uploadfile))
                {
                chmod($uploadfile, 0777);
                }
            else
                {
                return false;
                }

            $image_size        =$image['media_file']['size'];
            $temp              =getimagesize($uploadfile);
            $image_width       =$temp[0];
            $image_height      =$temp[1];
            $image_download_url='';

            $sql               ="update " . $this->table_prefix . "images set " . "cat_id='$cat_id',"
                . "user_id='$user_id'," . "image_name='$image_name'," . "image_description='$image_description',"
                . "image_keyword_ids='$image_keyword_ids'," . "image_create_time='$image_create_time',"
                . "image_edit_time='$image_edit_time'," . "image_active='$image_active',"
                . "image_filename='$image_filename'," . "image_size='$image_size'," . "image_width='$image_width',"
                . "image_height='$image_height'," . "image_download_url='$image_download_url',"
                . "image_downloads='$image_downloads'," . "image_votes='$image_votes',"
                . "image_rating='$image_rating'," . "image_hits='$image_hits'" . "where image_id=$image_id";
            $result            =$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }
            }
        else if (!checkBlank($data['remote_media_file']))
            {
            $image_filename=md5(uniqid(rand(), true)) . '_' . basename($data['remote_media_file']);
            $temp          =get_headers($data['remote_media_file'], true);

            if (!is_null($temp['Content-Length']) and is_numeric($temp['Content-Length']))
                {
                $image_size=$temp['Content-Length'];
                }

            $temp              =getimagesize($data['remote_media_file']);
            $image_width       =$temp[0];
            $image_height      =$temp[1];
            $image_download_url=$data['remote_media_file'];

            $sql               ="update " . $this->table_prefix . "images set " . "cat_id='$cat_id',"
                . "user_id='$user_id'," . "image_name='$image_name'," . "image_description='$image_description',"
                . "image_keyword_ids='$image_keyword_ids'," . "image_create_time='$image_create_time',"
                . "image_edit_time='$image_edit_time'," . "image_active='$image_active',"
                . "image_filename='$image_filename'," . "image_size='$image_size'," . "image_width='$image_width',"
                . "image_height='$image_height'," . "image_download_url='$image_download_url',"
                . "image_downloads='$image_downloads'," . "image_votes='$image_votes',"
                . "image_rating='$image_rating'," . "image_hits='$image_hits'" . "where image_id=$image_id";
            $result            =$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }
            }
        else
            {
            $sql   ="update " . $this->table_prefix . "images set " . "cat_id='$cat_id'," . "user_id='$user_id',"
                . "image_name='$image_name'," . "image_description='$image_description',"
                . "image_keyword_ids='$image_keyword_ids'," . "image_create_time='$image_create_time',"
                . "image_edit_time='$image_edit_time'," . "image_active='$image_active',"
                . "image_downloads='$image_downloads'," . "image_votes='$image_votes',"
                . "image_rating='$image_rating'," . "image_hits='$image_hits'" . "where image_id=$image_id";
            $result=$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }
            }

        return true;
        }

    public function del($ids)
        {
        foreach ($ids as $id)
            {
            $image = $this->searchById($id);

            if ($image['image_download_url'] == '')
                {
                $dest_folder=ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($image['cat_id']);
                $uploadfile =$dest_folder . $image['image_filename'];

                if (file_exists($uploadfile))
                    {
                    unlink ($uploadfile);
                    }
                }

            $sql   ="delete from " . $this->table_prefix . "images where image_id = '$id'";
            $result=$this->_db->query($sql);
            
            $GLOBALS['lightboxService']->delImages($id);
            $GLOBALS['commentService']->delImages($id); 
            }
        }

    public function search($data)
        {
        $sql='';
        $sql.="select * from " . $this->table_prefix . "images ";
        $condition='';

        $term_condition='';
        $terms=preg_split("/[\s]+/", $data['term'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            switch ($data['field'])
                {
                case "name":
                    if ($flag)
                        {
                        $term_condition.=" image_name like '%" . $term . "%'";
                        $flag=false;
                        }
                    else
                        {
                        $term_condition.=" and image_name like '%" . $term . "%'";
                        }

                    break;

                case "description":
                    if ($flag)
                        {
                        $term_condition.=" image_description like '%" . $term . "%'";
                        $flag=false;
                        }
                    else
                        {
                        $term_condition.=" and image_description like '%" . $term . "%'";
                        }

                    break;

                case "keywords":
                    $id=$GLOBALS['keywordService']->searchIdByText($term);

                    if ($flag)
                        {
                        $term_condition.=" image_keyword_ids like '%," . $id . ",%'";
                        $flag=false;
                        }
                    else
                        {
                        $term_condition.=" and image_keyword_ids like '%," . $id . ",%'";
                        }

                    break;

                case "all":
                    $id=$GLOBALS['keywordService']->searchIdByText($term);

                    if ($flag)
                        {
                        $term_condition.=" (image_name like '%" . $term . "%' or image_description like '%" . $term
                            . "%' or image_keyword_ids like '%," . $id . ",%')";
                        $flag=false;
                        }
                    else
                        {
                        $term_condition.=" and (image_name like '%" . $term . "%' or image_description like '%" . $term
                            . "%' or image_keyword_ids like '%," . $id . ",%')";
                        }

                    break;
                }
            }

        if ($term_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$term_condition;
                }
            else
                {
                $condition.=" and " . $term_condition;
                }
            }

        $category_condition='';

        if ($data['cat'] != "all")
            {
            $category_condition.=" cat_id =" . $data['cat'];
            }

        if ($category_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$category_condition;
                }
            else
                {
                $condition.=" and " . $category_condition;
                }
            }

        $orient_condition='';

        if ($data['orient'] == "vertical")
            {
            $orient_condition.=" image_width < image_height ";
            }
        else if ($data['orient'] == "horizontal")
            {
            $orient_condition.=" image_width >= image_height ";
            }

        if ($orient_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$orient_condition;
                }
            else
                {
                $condition.=" and " . $orient_condition;
                }
            }

        $user_condition='';
        $flag=true;

        if (trim($data['user']) != '')
            {
            $userids=$GLOBALS['userService']->searchIdsByName(trim($data['user']));

            if (count($userids) == 0)
                {
                $user_condition.=" user_id = 0 ";
                }
            else
                {
                foreach ($userids as $index => $user)
                    {
                    if ($flag)
                        {
                        $user_condition.=" user_id = " . $user['user_id'];
                        $flag=false;
                        }
                    else
                        {
                        $user_condition.=" or user_id = " . $user['user_id'];
                        }
                    }
                }
            }

        if ($user_condition != '')
            {
            if ($condition == '')
                {
                $condition.="(" . $user_condition . ")";
                }
            else
                {
                $condition.=" and (" . $user_condition . ")";
                }
            }

        $termx_condition='';
        $terms          =preg_split("/[\s]+/", $data['termx'], -1, PREG_SPLIT_NO_EMPTY);
        $flag           =true;

        foreach ($terms as $term)
            {
            $id = $GLOBALS['keywordService']->searchIdByText($term);

            if ($flag)
                {
                $termx_condition.=" (image_keyword_ids not like '%," . $id . ",%')";
                $flag=false;
                }
            else
                {
                $termx_condition.=" and (image_keyword_ids not like '%," . $id . ",%')";
                }
            }

        if ($termx_condition != '')
            {
            if ($condition == '')
                {
                $condition.="(" . $termx_condition . ")";
                }
            else
                {
                $condition.=" and (" . $termx_condition . ")";
                }
            }

        if ($condition == '')
            {
            $condition.=" image_active='1' ";
            }
        else
            {
            $condition.=" and image_active='1' ";
            }

        if ($condition != '')
            {
            $sql.=" where " . $condition;
            }

        switch ($data['sortby'])
            {
            case "newest":
                $sql.=" order by image_create_time DESC ";

                break;

            case "oldest":
                $sql.=" order by image_create_time ASC ";

                break;

            case "popular":
                $sql.=" order by image_downloads DESC ";

                break;

            case "name":
                $sql.=" order by image_name ";

                break;

            case "random": break;
            }

        $result=$this->_db->query($sql);
        $num=$this->_db->get_numrows($result);

        $sql.=" limit " . ($data['requestpage'] - 1) * $data['rows_per_page'] * 6 . " , "
            . ($data['rows_per_page'] * 6);
        $result=$this->_db->query($sql);
        $images=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);

        $this->_db->free_result($result);

        $pagecount  =ceil($num / ($data['rows_per_page'] * 6));
        $description=$this->create_description(trim($data['term']), $num);
        $navigation =create_navigation($pagecount, $data['requestpage']);

        return array
            (
            "des"    => $description,
            "nav"    => $navigation,
            "images" => $images
            );
        }

    public function searchByAdmin($data)
        {
        $sql='';
        $sql.="select " . $this->table_prefix . "images.image_id, " . $this->table_prefix . "images.image_name, "
            . $this->table_prefix . "images.image_filename, " . $this->table_prefix . "categories.cat_name, "
            . $this->table_prefix . "users.user_name, " . $this->table_prefix . "images.image_create_time, "
            . $this->table_prefix . "images.image_download_url FROM " . $this->table_prefix . "images, "
            . $this->table_prefix . "categories, " . $this->table_prefix . "users ";
        $condition='';

        $id_condition='';

        if (trim($data['id']) != '')
            {
            $id_condition.=" image_id =" . trim($data['id']);
            }

        if ($id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$id_condition;
                }
            else
                {
                $condition.=" and " . $id_condition;
                }
            }

        $name_condition='';
        $terms=preg_split("/[\s]+/", $data['name'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $name_condition.=" image_name like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $name_condition.=" and image_name like '%" . $term . "%'";
                }
            }

        if ($name_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$name_condition;
                }
            else
                {
                $condition.=" and " . $name_condition;
                }
            }

        $description_condition='';
        $terms=preg_split("/[\s]+/", $data['description'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $description_condition.=" image_description like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $description_condition.=" and image_description like '%" . $term . "%'";
                }
            }

        if ($description_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$description_condition;
                }
            else
                {
                $condition.=" and " . $description_condition;
                }
            }

        $keywords_condition='';
        $terms             =preg_split("/[\s]+/", $data['keywords'], -1, PREG_SPLIT_NO_EMPTY);
        $flag              =true;

        foreach ($terms as $term)
            {
            $id = $GLOBALS['keywordService']->searchIdByText($term);

            if ($flag)
                {
                $keywords_condition.=" image_keyword_ids like '%," . $id . ",%'";
                $flag=false;
                }
            else
                {
                $keywords_condition.=" and image_keyword_ids like '%," . $id . ",%'";
                }
            }

        if ($keywords_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$keywords_condition;
                }
            else
                {
                $condition.=" and " . $keywords_condition;
                }
            }

        $category_condition='';

        if ($data['category'] != "all")
            {
            $category_condition.=" " . $this->table_prefix . "images.cat_id =" . $data['category'];
            }

        if ($category_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$category_condition;
                }
            else
                {
                $condition.=" and " . $category_condition;
                }
            }

        $user_condition='';

        if ($data['user'] != "all")
            {
            $user_condition.=" " . $this->table_prefix . "images.user_id =" . $data['user'];
            }

        if ($user_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$user_condition;
                }
            else
                {
                $condition.=" and " . $user_condition;
                }
            }

        $filename_condition='';

        if (trim($data['filename']) != '')
            {
            $filename_condition.=" image_filename ='" . substr(trim($data['filename']), 33) . "'";
            }

        if ($filename_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$filename_condition;
                }
            else
                {
                $condition.=" and " . $filename_condition;
                }
            }

        $dateafter_condition='';
        $data['dateafter']=timeTrans($data['dateafter']);

        if (trim($data['dateafter']) != '')
            {
            $dateafter_condition.=" image_create_time >= " . trim($data['dateafter']);
            }

        if ($dateafter_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$dateafter_condition;
                }
            else
                {
                $condition.=" and " . $dateafter_condition;
                }
            }

        $datebefore_condition='';
        $data['datebefore']  =timeTrans($data['datebefore']);

        if (trim($data['datebefore']) != '')
            {
            $datebefore_condition.=" image_create_time <= " . trim($data['datebefore']);
            }

        if ($datebefore_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$datebefore_condition;
                }
            else
                {
                $condition.=" and " . $datebefore_condition;
                }
            }

        $downloadshigher_condition='';

        if (trim($data['downloadshigher']) != '')
            {
            $downloadshigher_condition.=" image_downloads >= " . trim($data['downloadshigher']);
            }

        if ($downloadshigher_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$downloadshigher_condition;
                }
            else
                {
                $condition.=" and " . $downloadshigher_condition;
                }
            }

        $downloadslower_condition='';

        if (trim($data['downloadslower']) != '')
            {
            $downloadslower_condition.=" image_downloads <= " . trim($data['downloadslower']);
            }

        if ($downloadslower_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$downloadslower_condition;
                }
            else
                {
                $condition.=" and " . $downloadslower_condition;
                }
            }

        $ratinghigher_condition='';

        if (trim($data['ratinghigher']) != '')
            {
            $ratinghigher_condition.=" image_rating >= " . trim($data['ratinghigher']);
            }

        if ($ratinghigher_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$ratinghigher_condition;
                }
            else
                {
                $condition.=" and " . $ratinghigher_condition;
                }
            }

        $ratinglower_condition='';

        if (trim($data['ratinglower']) != '')
            {
            $ratinglower_condition.=" image_rating <= " . trim($data['ratinglower']);
            }

        if ($ratinglower_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$ratinglower_condition;
                }
            else
                {
                $condition.=" and " . $ratinglower_condition;
                }
            }

        $voteshigher_condition='';

        if (trim($data['voteshigher']) != '')
            {
            $voteshigher_condition.=" image_votes >= " . trim($data['voteshigher']);
            }

        if ($voteshigher_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$voteshigher_condition;
                }
            else
                {
                $condition.=" and " . $voteshigher_condition;
                }
            }

        $voteslower_condition='';

        if (trim($data['voteslower']) != '')
            {
            $voteslower_condition.=" image_votes <= " . trim($data['voteslower']);
            }

        if ($voteslower_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$voteslower_condition;
                }
            else
                {
                $condition.=" and " . $voteslower_condition;
                }
            }

        $hitshigher_condition='';

        if (trim($data['hitshigher']) != '')
            {
            $hitshigher_condition.=" image_hits >= " . trim($data['hitshigher']);
            }

        if ($hitshigher_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$hitshigher_condition;
                }
            else
                {
                $condition.=" and " . $hitshigher_condition;
                }
            }

        $hitslower_condition='';

        if (trim($data['hitslower']) != '')
            {
            $hitslower_condition.=" image_hits <= " . trim($data['hitslower']);
            }

        if ($hitslower_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$hitslower_condition;
                }
            else
                {
                $condition.=" and " . $hitslower_condition;
                }
            }

        $active_condition='';

        if (trim($data['active']) == '1')
            {
            $active_condition.=" image_active='1' ";
            }
        else if (trim($data['active']) == '0')
            {
            $active_condition.=" image_active='0' ";
            }

        if ($active_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$active_condition;
                }
            else
                {
                $condition.=" and " . $active_condition;
                }
            }

        $remote_condition='';

        if (trim($data['remote']) == '1')
            {
            $remote_condition.=" image_download_url != '' ";
            }
        else if (trim($data['remote']) == '0')
            {
            $remote_condition.=" image_download_url = '' ";
            }

        if ($remote_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$remote_condition;
                }
            else
                {
                $condition.=" and " . $remote_condition;
                }
            }

        $sql.=" where " . $this->table_prefix . "images.cat_id = " . $this->table_prefix . "categories.cat_id and "
            . $this->table_prefix . "images.user_id = " . $this->table_prefix . "users.user_id ";

        if ($condition != '')
            {
            $sql.=" and " . $condition;
            }

        switch ($data['sortby'])
            {
            case "name":
                $sql.=" order by image_name " . $data['direction'];

                break;

            case "category":
                $sql.=" order by " . $this->table_prefix . "images.cat_id " . $data['direction'];

                break;

            case "filename":
                $sql.=" order by image_filename " . $data['direction'];

                break;

            case "date":
                $sql.=" order by image_create_time " . $data['direction'];

                break;

            case "downloads":
                $sql.=" order by image_downloads " . $data['direction'];

                break;

            case "rating":
                $sql.=" order by image_rating " . $data['direction'];

                break;

            case "votes":
                $sql.=" order by image_votes " . $data['direction'];

                break;

            case "hits":
                $sql.=" order by image_hits " . $data['direction'];

                break;
            }

        $result=$this->_db->query($sql);
        $num=$this->_db->get_numrows($result);
        $sql.=" limit " . ($data['requestpage'] - 1) * $data['rows_per_page'] . " , " . ($data['rows_per_page']);
        $result=$this->_db->query($sql);
        $images=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $pagecount =ceil($num / ($data['rows_per_page']));
        $navigation=create_navigation($pagecount, $data['requestpage']);
        return array
            (
            "nav"    => $navigation,
            "images" => $images
            );
        }

    public function searchById($imageId)
        {
        $sql="select * from " . $this->table_prefix . "images, " . $this->table_prefix . "categories, "
            . $this->table_prefix . "users where image_id=" . $imageId . " and ";
        $sql.="" . $this->table_prefix . "images.cat_id = " . $this->table_prefix . "categories.cat_id and "
            . $this->table_prefix . "images.user_id = " . $this->table_prefix . "users.user_id ";
        $result=$this->_db->query($sql);
        $image =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $image;
        }

    public function searchCommentsById($imageId)
        {
        $sql     ="select * from " . $this->table_prefix . "comments, " . $this->table_prefix . "users where image_id="
            . $imageId . " and " . $this->table_prefix . "comments.user_id = " . $this->table_prefix
            . "users.user_id order by comment_date desc;";
        $result  =$this->_db->query($sql);
        $comments=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $comments;
        }

    public function searchTop($type)
        {
        $sql   ="select * from " . $this->table_prefix . "images order by image_$type desc limit 0,5";
        $result=$this->_db->query($sql);
        $images=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $images;
        }

    public function incHits($imageId)
        {
        $sql   ="update " . $this->table_prefix . "images set image_hits=image_hits+1 where image_id = '$imageId'";
        $result=$this->_db->query($sql);
        }

    public function incDownloads($imageId)
        {
        $sql   ="update " . $this->table_prefix
            . "images set image_downloads=image_downloads+1 where image_id = '$imageId'";
        $result=$this->_db->query($sql);
        }

    public function rating($data)
        {
        if (is_numeric($data['rating']))
            {
            $sql   ="update " . $this->table_prefix . "images set image_votes=image_votes+1 where image_id = "
                . $data['id'];
            $result=$this->_db->query($sql);
            $sql   ="update " . $this->table_prefix . "images set image_rating=(image_rating*(image_votes-1)+"
                . $data['rating'] . ")/image_votes";
            $result=$this->_db->query($sql);
            }
        }

    public function imageFullPath($imageId)
        {
        $sql   ="select cat_id from " . $this->table_prefix . "images where image_id=" . $imageId;
        $result=$this->_db->query($sql);
        $data  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $categoryId=$data['cat_id'];
        $dirpath   =ROOT_PATH . $GLOBALS['categoryService']->directoryFullPath($categoryId);
        return $dirpath;
        }

    private function convertWordToCode($keyword)
        {
        $code='';

        if ($keyword == '')
            {
            return '';
            }
        else
            {
            $items=preg_split("/[\s]+/", $keyword, -1, PREG_SPLIT_NO_EMPTY);
            $flag =true;

            foreach ($items as $item)
                {
                if ($GLOBALS['keywordService']->exist($item))
                    {
                    $id=$GLOBALS['keywordService']->searchIdByText($item);
                    }
                else
                    {
                    $id=$GLOBALS['keywordService']->insert($item);
                    }

                if ($flag)
                    {
                    $code.="," . $id . ",";
                    $flag=false;
                    }
                else
                    {
                    $code.=$id . ",";
                    }
                }

            return $code;
            }
        }

    public function convertCodeToWord($keyword)
        {
        $word='';

        if ($keyword == '')
            {
            return '';
            }
        else
            {
            $items=preg_split("/,/", $keyword, -1, PREG_SPLIT_NO_EMPTY);
            $flag =true;

            foreach ($items as $item)
                {
                $text = $GLOBALS['keywordService']->searchTextById($item);

                if ($flag)
                    {
                    $word.=$text;
                    $flag=false;
                    }
                else
                    {
                    $word.=" " . $text;
                    }
                }

            return $word;
            }
        }

    private function create_description($term, $num)
        {
        global $lang;
        $description    ='';
        $patterns[0]    ='/#term/';
        $patterns[1]    ='/#num/';
        $replacements[0]='$term';
        $replacements[1]='$num';
        $description    =preg_replace($patterns, $replacements, $lang['home_viewdes']);
        eval ("\$description = \"$description\";");
        return $description;
        }
        
    public function getActiveNumDes()
    {
        global $lang;   
        $description    =''; 
        $sql   ="select count(*) as num from " . $this->table_prefix . "images where image_active=1";
        $result=$this->_db->query($sql);
        $num   =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $description    =preg_replace("/#num/", $num['num'], $lang['header_total']);
        return $description; 
    }

    public function download($imageId, $size, $gzip)
        {
        if (!$gzip)
            {
            $tempDir=ROOT_PATH . TEMP_PATH . session_id() . "/";

            if (!file_exists($tempDir))
                {
                mkdir($tempDir, 0777);
                }

            $sql   ="select * from " . $this->table_prefix . "images where image_id=" . $imageId;
            $result=$this->_db->query($sql);
            $image =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
            $this->_db->free_result($result);

            $dstImage=$tempDir . substr($image['image_filename'], 32 + 1);

            if ($image['image_download_url'] == '')
                {
                $srcImage=$this->imageFullPath($imageId) . $image['image_filename'];
                }
            else
                {
                $srcImage=$image['image_download_url'];
                }

            if ($size == "small")
                {
                $temp=1 / 3;
                }
            elseif ($size == "medium")
                {
                $temp=1 / 2;
                }
            elseif ($size == "large")
                {
                $temp=1 / 1;
                }

            $this->createImage($srcImage, $dstImage, $image['image_width'] * $temp, $image['image_height'] * $temp);
            $this->sendFile(substr($image['image_filename'], 32 + 1), $dstImage);
            $GLOBALS['categoryService']->delDir($tempDir);
            }
        }

    private function createImage($srcImage, $desImage, $dstW, $dstH)
        {
        $data=GetImageSize($srcImage);

        switch ($data['mime'])
            {
            case 'image/gif':
                if (imagetypes() & IMG_GIF)
                    {
                    $im=ImageCreateFromGIF($srcImage);
                    }

                break;

            case 'image/jpeg':
                if (imagetypes() & IMG_JPG)
                    {
                    $im=imagecreatefromjpeg($srcImage);
                    }

                break;

            case 'image/png':
                if (imagetypes() & IMG_PNG)
                    {
                    $im=ImageCreateFromPNG($srcImage);
                    }

                break;

            case 'image/wbmp':
                if (imagetypes() & IMG_WBMP)
                    {
                    $im=imageCreateFromWBMP($srcImage);
                    }

                break;
            }

        $srcW=$data[0];
        $srcH=$data[1];
        $ni  =ImageCreateTrueColor($dstW, $dstH);
        imagecopyresampled($ni, $im, 0, 0, 0, 0, $dstW, $dstH, $srcW, $srcH);
        imageJPEG($ni, $desImage);
        imagedestroy ($im);
        imagedestroy ($ni);
        }

    private function sendFile($file_name, $file_path)
        {
        $data          =$this->get_file_data($file_path);
        $file_extension=file_extension($file_name);

        switch ($file_extension)
            {
            case "pdf":
                $ctype="application/pdf";

                break;

            case "exe":
                $ctype="application/octet-stream";

                break;

            case "zip":
                $ctype="application/zip";

                break;

            case "doc":
                $ctype="application/msword";

                break;

            case "xls":
                $ctype="application/vnd.ms-excel";

                break;

            case "ppt":
                $ctype="application/vnd.ms-powerpoint";

                break;

            case "gif":
                $ctype="image/gif";

                break;

            case "png":
                $ctype="image/png";

                break;

            case "jpeg":
            case "jpg":
                $ctype="image/jpg";

                break;

            case "mp3":
                $ctype="audio/mpeg";

                break;

            case "wav":
                $ctype="audio/x-wav";

                break;

            case "mpeg":
            case "mpg":
            case "mpe":
                $ctype="video/mpeg";

                break;

            case "mov":
                $ctype="video/quicktime";

                break;

            case "avi":
                $ctype="video/x-msvideo";

                break;

            //The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
            case "php":
            case "htm":
            case "html":
            case "txt":
                die ("<b>Cannot be used for " . $file_extension . " files!</b>");

                break;

            default: $ctype="application/force-download";
            }

        header ("Pragma: public");
        header ("Expires: 0");
        header ("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header ("Cache-Control: public");
        header ("Content-Description: File Transfer");
        header ("Content-Transfer-Encoding: binary");
        $disposition=(eregi("\.zip$", $file_name)) ? 'inline' : 'attachment';
        header ("Content-Disposition: $disposition; filename=\"" . $file_name . "\"\n");
        header ("Content-Type: $ctype\n");
        header ("Content-Length: " . strlen($data) . "\n\n");

        echo $data;
        }

    private function get_file_data($file_path)
        {
        ob_start();
        ob_implicit_flush (0);
        readfile ($file_path);
        $file_data=ob_get_contents();
        ob_end_clean();

        if (!empty($file_data))
            {
            return $file_data;
            }
        }
    }
?>